package com.nantian.cloud.jly.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.nantian.cloud.jly.entity.CheckStore;
import com.nantian.cloud.jly.entity.InspectionData;
import com.nantian.cloud.jly.mapper.CheckStoreMapper;
import com.nantian.cloud.jly.service.CheckStoreService;
import com.nantian.cloud.jly.service.InspectionDataService;
import com.nantian.sc.cloud.common.core.util.R;
import com.nantian.sc.cloud.common.security.service.ScUser;
import com.nantian.sc.cloud.common.security.util.SecurityUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.math.BigInteger;
import java.util.Date;

/**
 * @date 2018-09-27
 */
@Service("CheckStoreService")
public class CheckStoreServiceImpl extends ServiceImpl<CheckStoreMapper, CheckStore> implements CheckStoreService {


    @Autowired
    private InspectionDataService inspectionDataService;

    private static final String EXTENSION_XLS = "xls";
    private static final String EXTENSION_XLSX = "xlsx";

    @Override
    public R excelImport(MultipartFile file, BigInteger checkPlanId, String epc, InspectionData inspectionData) {
        if (file == null) {
            //throw new FileFormatException("");
            return R.failed("导入失败，传入文件不存在！");
        }

        //获取原文件
        String originalFileName = file.getOriginalFilename();

        //判断传入文件格式
        if (!(originalFileName.endsWith(EXTENSION_XLS) || originalFileName.endsWith(EXTENSION_XLSX))) {
            //throw new FileFormatException("传入文件不是excel格式!");
            return R.failed("传入文件不是excel格式!");
        }
        Workbook workbook = null;
        try {
            if (originalFileName.endsWith(EXTENSION_XLS)) {
                workbook = new HSSFWorkbook(file.getInputStream());
            } else if (originalFileName.endsWith(EXTENSION_XLSX)) {
                workbook = new XSSFWorkbook(file.getInputStream());
            }

            //读文件
            for (int numSheet = 0; numSheet < workbook.getNumberOfSheets(); numSheet++) {
                org.apache.poi.ss.usermodel.Sheet sheet = workbook.getSheetAt(numSheet);
                if (sheet == null) {
                    continue;
                }
                int firstRowIndex = sheet.getFirstRowNum();
                int lastRowIndex = sheet.getLastRowNum();
                //读取首行（表头）
                Row firstRow = sheet.getRow(firstRowIndex);
                for (int i = firstRow.getFirstCellNum(); i <= firstRow.getLastCellNum(); i++) {
                    Cell cell = firstRow.getCell(i);
                    String cellValue = this.getCellValue(cell, true);
                    System.err.println("表头数据：" + cellValue + "\t");
                }

                System.err.println("开始导入数据...");
                CheckStore checkStore = new CheckStore();
                //从第4行开始才有数据
                for (int rowIndex = firstRowIndex + 3; rowIndex <= lastRowIndex; rowIndex++) {
                    Row currentRow = sheet.getRow(rowIndex);
                    int firstColumnIndex = currentRow.getFirstCellNum(); //首列
                    int lastColumnIndex = currentRow.getLastCellNum(); //尾列
                    boolean s = false;

                    for (int columnIndex = firstColumnIndex; columnIndex <= lastColumnIndex; columnIndex++) {
                        Cell currentCell = currentRow.getCell(columnIndex);
                        String currentCellValue = this.getCellValue(currentCell, true);
                        System.err.println(" " + currentCellValue + "\t");
                        if (columnIndex == firstColumnIndex) {
                            //能源种类及名称
                            if (currentCellValue != null && !currentCellValue.equals("")) {
                                checkStore.setNum(Integer.valueOf(currentCellValue));
                            }
                        }
                        if (columnIndex == firstColumnIndex + 1) {
                            checkStore.setEnergyName(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 2) {
                            checkStore.setUnit(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 3) {
                            checkStore.setCodes(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 4) {
                            checkStore.setStoreNum(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 5) {
                            checkStore.setBuyNum(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 6) {
                            checkStore.setBuyPrice(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 7) {
                            checkStore.setUseTotal(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 8) {
                            checkStore.setUseProduct(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 9) {
                            checkStore.setUseMaterial(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 10) {
                            checkStore.setUseNoProduct(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 11) {
                            checkStore.setUseForTrans(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 12) {
                            checkStore.setStoreEnd(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 13) {
                            checkStore.setModulus(currentCellValue);
                        }
                        if (columnIndex == firstColumnIndex + 14) {
                            checkStore.setModulusRef(currentCellValue);
                        }
                    }
                    ScUser u = SecurityUtils.getUser();
                    checkStore.setUserid(u.getId());
                    checkStore.setDeptId(u.getDeptId());
                    checkStore.setDelFlag("1");
                    checkStore.setUpdateTime(new Date());
                    checkStore.setCheckPlanId(checkPlanId);
                    checkStore.setEpc(epc);
                    if (checkStore.getUseTotal() != "" && checkStore.getModulus() != "" && checkStore.getUseTotal() != null && checkStore.getModulus() != null) {
                        try {
                            checkStore.setMop(String.valueOf(Float.parseFloat(checkStore.getUseTotal()) * Float.parseFloat(checkStore.getModulus())));
                        } catch (Exception e) {
                            // TODO Auto-generated catch block
                            checkStore.setMop(null);
                        }
                    }
//                    if(checkStore.getUseProduct() != null && checkStore.getUseProduct() != ""){
                    this.save(checkStore);
//                    }


                    inspectionData.setInventoryStatus("Y");
                    inspectionDataService.updateById(inspectionData);  //更新中间表
                }
            }
            return R.ok("导入成功");
        } catch (Exception e) {
            System.err.println(e.getMessage());
            e.printStackTrace();
            return R.failed("导入失败！" + e.getMessage());
        } finally {
            if (workbook != null) {
                try {
                    file.getInputStream().close();
                    workbook.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private String getCellValue(Cell cell, boolean b) {
        if (cell == null) {
            return "";
        }
        if (b) {
            //虽然excel中设置的都是文本，但是数字文本还被读错，如“1”取成“1.0”,加上下面这句，临时把它当做文本来读取
            cell.setCellType(Cell.CELL_TYPE_STRING);
        }
        if (cell.getCellType() == Cell.CELL_TYPE_BOOLEAN) {
            return String.valueOf(cell.getBooleanCellValue());
        } else if (cell.getCellType() == Cell.CELL_TYPE_NUMERIC) {
            return String.valueOf(cell.getNumericCellValue());
        } else {
            return String.valueOf(cell.getStringCellValue());
        }
    }
}

